export interface EnhancedNumberInterface {
	readonly number: number;
	_divisors: number[] | undefined;
	_factorsOf:
		| {
				prime: number;
				power: number;
		  }[]
		| undefined;
	_getAliquotSum: number | undefined;
	_getCenteredHexagonal: number | undefined;
	_getCountDivisors: number | undefined;
	_getIntRoot: number | boolean | undefined;
	_getPoliteness: number | undefined;
	_getStar: number | undefined;
	_getTetrahedral: number | undefined;
	_hasIntRoot: boolean | undefined;
	_isAbundant: boolean | undefined;
	_isArithmetic: boolean | undefined;
	_isEvil: boolean | undefined;
	_isHappy: {
		[k: string]: boolean | undefined;
	};
	_isImpolite: boolean | undefined;
	_isMersennePrime: boolean | undefined;
	_isNatural: boolean | undefined;
	_isOdd: boolean | undefined;
	_isOdious: boolean | undefined;
	_isPerfect: boolean | undefined;
	_isPolite: boolean | undefined;
	_isPowerOf2: boolean | undefined;
	_isPractical: boolean | undefined;
	_isPrime: boolean | undefined;
	_isPrimePower: boolean | undefined;
	_isPronic: boolean | undefined;
	_isRound: {
		[k: string]: boolean | undefined;
	};
	_isSad: {
		[k: string]: boolean | undefined;
	};
	_isSafePrime: boolean | undefined;
	_isSelf: {
		[k: string]: boolean | undefined;
	};
	_isSelfPrime: boolean | undefined;
	_isSemiperfect: boolean | undefined;
	_isSophieGermainPrime: boolean | undefined;
	_isSphenic: boolean | undefined;
	_isStar: boolean | undefined;
	_isTetrahedral: boolean | undefined;
	_isUntouchable: boolean | undefined;
	_isUnusual: boolean | undefined;
	_isWeird: boolean | undefined;
	_isWhole: boolean | undefined;
	_mobius: number | undefined;
	_number: number | undefined;
	_semiperfectTest: boolean | undefined;
	_sieve: number[] | undefined;
	divisors: number[];
	factorsOf: {
		prime: number;
		power: number;
	}[];
	getAliquotSum: number;
	getCenteredHexagonal: number;
	getCountDivisors: number;
	getIntRoot: number | boolean;
	getPoliteness: number;
	getStar: number;
	getTetrahedral: number;
	hasIntRoot: boolean;
	isAbundant: boolean;
	isArithmetic: boolean;
	isCenteredHexagonal: boolean;
	isEven: boolean;
	isEvil: boolean;
	isHappy: boolean;
	isImpolite: boolean;
	isMersennePrime: boolean;
	isNatural: boolean;
	isOdd: boolean;
	isOdious: boolean;
	isPerfect: boolean;
	isPolite: boolean;
	isPowerOf2: boolean;
	isPractical: boolean;
	isPrime: boolean;
	isPrimePower: boolean;
	isPronic: boolean;
	isRound: boolean;
	isSad: boolean;
	isSafePrime: boolean;
	isSelf: boolean;
	isSelfPrime: boolean;
	isSemiperfect: boolean;
	isSophieGermainPrime: boolean;
	isSphenic: boolean;
	isStar: boolean;
	isTetrahedral: boolean;
	isUntouchable: boolean;
	isUnusual: boolean;
	isWeird: boolean;
	isWhole: boolean;
	mobius: number;
	semiperfectTest: boolean;
	sieve: number[];
	toString: () => string;
	toNumber: () => number;
}
export declare function unknownIsEnhancedNumber(
	n: unknown
): n is EnhancedNumber;
export declare class EnhancedNumber implements EnhancedNumberInterface {
	[key: string]: any;
	_divisors: number[] | undefined;
	_factorsOf:
		| {
				prime: number;
				power: number;
		  }[]
		| undefined;
	_getAliquotSum: number | undefined;
	_getCenteredHexagonal: number | undefined;
	_getCountDivisors: number | undefined;
	_getIntRoot: number | boolean | undefined;
	_getPoliteness: number | undefined;
	_getStar: number | undefined;
	_getTetrahedral: number | undefined;
	_hasIntRoot: boolean | undefined;
	_isAbundant: boolean | undefined;
	_isArithmetic: boolean | undefined;
	_isCenteredHexagonal: boolean | undefined;
	_isEven: boolean | undefined;
	_isEvil: boolean | undefined;
	_isHappy: {
		[k: string]: boolean | undefined;
	};
	_isImpolite: boolean | undefined;
	_isMersennePrime: boolean | undefined;
	_isNatural: boolean | undefined;
	_isOdd: boolean | undefined;
	_isOdious: boolean | undefined;
	_isPerfect: boolean | undefined;
	_isPolite: boolean | undefined;
	_isPowerOf2: boolean | undefined;
	_isPractical: boolean | undefined;
	_isPrime: boolean | undefined;
	_isPrimePower: boolean | undefined;
	_isPronic: boolean | undefined;
	_isRound: {
		[k: string]: boolean | undefined;
	};
	_isSad: {
		[k: string]: boolean | undefined;
	};
	_isSafePrime: boolean | undefined;
	_isSelf: {
		[k: string]: boolean | undefined;
	};
	_isSelfPrime: boolean | undefined;
	_isSemiperfect: boolean | undefined;
	_isSophieGermainPrime: boolean | undefined;
	_isSphenic: boolean | undefined;
	_isStar: boolean | undefined;
	_isTetrahedral: boolean | undefined;
	_isUntouchable: boolean | undefined;
	_isUnusual: boolean | undefined;
	_isWeird: boolean | undefined;
	_isWhole: boolean | undefined;
	_mobius: number | undefined;
	_semiperfectTest: boolean | undefined;
	_sieve: number[] | undefined;
	_number: number;
	constructor(n: number | EnhancedNumber);
	toString(): string;
	toNumber(): number;
	set number(v: number);
	get number(): number;
	set divisors(v: number[]);
	get divisors(): number[];
	set getStar(v: number);
	get getStar(): number;
	set isEvil(v: boolean);
	get isEvil(): boolean;
	set isOdd(v: boolean);
	get isOdd(): boolean;
	set isPrime(v: boolean);
	get isPrime(): boolean;
	set isSafePrime(v: boolean);
	get isSafePrime(): boolean;
	set isStar(v: boolean);
	get isStar(): boolean;
	set factorsOf(
		v: {
			prime: number;
			power: number;
		}[]
	);
	get factorsOf(): {
		prime: number;
		power: number;
	}[];
	set getTetrahedral(v: number);
	get getTetrahedral(): number;
	set isHappy(v: boolean);
	get isHappy(): boolean;
	set isOdious(v: boolean);
	get isOdious(): boolean;
	set isPrimePower(v: boolean);
	get isPrimePower(): boolean;
	set isSelf(v: boolean);
	get isSelf(): boolean;
	set mobius(v: number);
	get mobius(): number;
	set getAliquotSum(v: number);
	get getAliquotSum(): number;
	set hasIntRoot(v: boolean);
	get hasIntRoot(): boolean;
	set isImpolite(v: boolean);
	get isImpolite(): boolean;
	set isPerfect(v: boolean);
	get isPerfect(): boolean;
	set isSelfPrime(v: boolean);
	get isSelfPrime(): boolean;
	set isTetrahedral(v: boolean);
	get isTetrahedral(): boolean;
	set getCenteredHexagonal(v: number);
	get getCenteredHexagonal(): number;
	set isAbundant(v: boolean);
	get isAbundant(): boolean;
	set isPolite(v: boolean);
	get isPolite(): boolean;
	set isPronic(v: boolean);
	get isPronic(): boolean;
	set isSemiperfect(v: boolean);
	get isSemiperfect(): boolean;
	set isUntouchable(v: boolean);
	get isUntouchable(): boolean;
	set getCountDivisors(v: number);
	get getCountDivisors(): number;
	set isArithmetic(v: boolean);
	get isArithmetic(): boolean;
	set isMersennePrime(v: boolean);
	get isMersennePrime(): boolean;
	set isPowerOf2(v: boolean);
	get isPowerOf2(): boolean;
	set isUnusual(v: boolean);
	get isUnusual(): boolean;
	set semiperfectTest(v: boolean);
	get semiperfectTest(): boolean;
	set getIntRoot(v: number | boolean);
	get getIntRoot(): number | boolean;
	set isCenteredHexagonal(v: boolean);
	get isCenteredHexagonal(): boolean;
	set isRound(v: boolean);
	get isRound(): boolean;
	set isSophieGermainPrime(v: boolean);
	get isSophieGermainPrime(): boolean;
	set isWeird(v: boolean);
	get isWeird(): boolean;
	set sieve(v: number[]);
	get sieve(): number[];
	set getPoliteness(v: number);
	get getPoliteness(): number;
	set isEven(v: boolean);
	get isEven(): boolean;
	set isNatural(v: boolean);
	get isNatural(): boolean;
	set isPractical(v: boolean);
	get isPractical(): boolean;
	set isSad(v: boolean);
	get isSad(): boolean;
	set isSphenic(v: boolean);
	get isSphenic(): boolean;
	set isWhole(v: boolean);
	get isWhole(): boolean;
}
export declare const instantiatedNumbers: {
	[k: string]: EnhancedNumber;
};
export declare function backupComputations(
	inputN: number | EnhancedNumber
): void;
export declare function restoreComputations(inputN: number): void;
//# sourceMappingURL=enhancedNumber.d.ts.map
