"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.restoreComputations =
	exports.backupComputations =
	exports.instantiatedNumbers =
	exports.EnhancedNumber =
	exports.unknownIsEnhancedNumber =
		void 0;
const tslib_1 = require("tslib");
const fs_1 = tslib_1.__importDefault(require("fs"));
const divisors_1 = require("../lib/divisors");
const factorsOf_1 = require("../lib/factorsOf");
const getAliquotSum_1 = require("../lib/getAliquotSum");
const getCenteredHexagonal_1 = require("../lib/getCenteredHexagonal");
const getCountDivisors_1 = require("../lib/getCountDivisors");
const getIntRoot_1 = require("../lib/getIntRoot");
const getPoliteness_1 = require("../lib/getPoliteness");
const getStar_1 = require("../lib/getStar");
const getTetrahedral_1 = require("../lib/getTetrahedral");
const hasIntRoot_1 = require("../lib/hasIntRoot");
const isAbundant_1 = require("../lib/isAbundant");
const isArithmetic_1 = require("../lib/isArithmetic");
const isCenteredHexagonal_1 = require("../lib/isCenteredHexagonal");
const isEven_1 = require("../lib/isEven");
const isEvil_1 = require("../lib/isEvil");
const isHappy_1 = require("../lib/isHappy");
const isImpolite_1 = require("../lib/isImpolite");
const isMersennePrime_1 = require("../lib/isMersennePrime");
const isNatural_1 = require("../lib/isNatural");
const isOdd_1 = require("../lib/isOdd");
const isOdious_1 = require("../lib/isOdious");
const isPerfect_1 = require("../lib/isPerfect");
const isPolite_1 = require("../lib/isPolite");
const isPowerOf2_1 = require("../lib/isPowerOf2");
const isPractical_1 = require("../lib/isPractical");
const isPrime_1 = require("../lib/isPrime");
const isPrimePower_1 = require("../lib/isPrimePower");
const isPronic_1 = require("../lib/isPronic");
const isSad_1 = require("../lib/isSad");
const isSafePrime_1 = require("../lib/isSafePrime");
const isSelf_1 = require("../lib/isSelf");
const isSelfPrime_1 = require("../lib/isSelfPrime");
const isSemiperfect_1 = require("../lib/isSemiperfect");
const isSophieGermainPrime_1 = require("../lib/isSophieGermainPrime");
const isSphenic_1 = require("../lib/isSphenic");
const isStar_1 = require("../lib/isStar");
const isTetrahedral_1 = require("../lib/isTetrahedral");
const isUntouchable_1 = require("../lib/isUntouchable");
const isUnusual_1 = require("../lib/isUnusual");
const isWeird_1 = require("../lib/isWeird");
const isWhole_1 = require("../lib/isWhole");
const mobius_1 = require("../lib/mobius");
const semiperfectTest_1 = require("../lib/semiperfectTest");
const sieve_1 = require("../lib/sieve");
function unknownIsEnhancedNumber(n) {
	return typeof n === "object" && n !== null && "number" in n;
}
exports.unknownIsEnhancedNumber = unknownIsEnhancedNumber;
class EnhancedNumber {
	constructor(n) {
		this._divisors = undefined;
		this._factorsOf = undefined;
		this._getAliquotSum = undefined;
		this._getCenteredHexagonal = undefined;
		this._getCountDivisors = undefined;
		this._getIntRoot = undefined;
		this._getPoliteness = undefined;
		this._getStar = undefined;
		this._getTetrahedral = undefined;
		this._hasIntRoot = undefined;
		this._isAbundant = undefined;
		this._isArithmetic = undefined;
		this._isCenteredHexagonal = undefined;
		this._isEven = undefined;
		this._isEvil = undefined;
		this._isHappy = {};
		this._isImpolite = undefined;
		this._isMersennePrime = undefined;
		this._isNatural = undefined;
		this._isOdd = undefined;
		this._isOdious = undefined;
		this._isPerfect = undefined;
		this._isPolite = undefined;
		this._isPowerOf2 = undefined;
		this._isPractical = undefined;
		this._isPrime = undefined;
		this._isPrimePower = undefined;
		this._isPronic = undefined;
		this._isRound = {};
		this._isSad = {};
		this._isSafePrime = undefined;
		this._isSelf = {};
		this._isSelfPrime = undefined;
		this._isSemiperfect = undefined;
		this._isSophieGermainPrime = undefined;
		this._isSphenic = undefined;
		this._isStar = undefined;
		this._isTetrahedral = undefined;
		this._isUntouchable = undefined;
		this._isUnusual = undefined;
		this._isWeird = undefined;
		this._isWhole = undefined;
		this._mobius = undefined;
		this._semiperfectTest = undefined;
		this._sieve = undefined;
		this._number = 0;
		if (unknownIsEnhancedNumber(n)) {
			return n;
		} else if (exports.instantiatedNumbers[n.toString()] !== undefined) {
			return exports.instantiatedNumbers[n.toString()];
		}
		this._number = n;
		exports.instantiatedNumbers[n.toString()] = this;
		return this;
	}
	toString() {
		return this.number.toString();
	}
	toNumber() {
		return this.number;
	}
	set number(v) {
		throw "base value of EnhancedNumber can not be changed, please instantiate a new instance of EnhancedNumber";
	}
	get number() {
		return this._number;
	}
	set divisors(v) {
		this._divisors = v;
	}
	get divisors() {
		return this._divisors !== undefined
			? this._divisors
			: (this._divisors = (0, divisors_1.divisors)(this));
	}
	set getStar(v) {
		this._getStar = v;
	}
	get getStar() {
		return this._getStar !== undefined
			? this._getStar
			: (this._getStar = (0, getStar_1.getStar)(this));
	}
	set isEvil(v) {
		this._isEvil = v;
	}
	get isEvil() {
		return this._isEvil !== undefined
			? this._isEvil
			: (this._isEvil = (0, isEvil_1.isEvil)(this));
	}
	set isOdd(v) {
		this._isOdd = v;
	}
	get isOdd() {
		return this._isOdd !== undefined
			? this._isOdd
			: (this._isOdd = (0, isOdd_1.isOdd)(this));
	}
	set isPrime(v) {
		this._isPrime = v;
	}
	get isPrime() {
		return this._isPrime !== undefined
			? this._isPrime
			: (this._isPrime = (0, isPrime_1.isPrime)(this));
	}
	set isSafePrime(v) {
		this._isSafePrime = v;
	}
	get isSafePrime() {
		return this._isSafePrime !== undefined
			? this._isSafePrime
			: (this._isSafePrime = (0, isSafePrime_1.isSafePrime)(this));
	}
	set isStar(v) {
		this._isStar = v;
	}
	get isStar() {
		return this._isStar !== undefined
			? this._isStar
			: (this._isStar = (0, isStar_1.isStar)(this));
	}
	set factorsOf(v) {
		this._factorsOf = v;
	}
	get factorsOf() {
		return this._factorsOf !== undefined
			? this._factorsOf
			: (this._factorsOf = (0, factorsOf_1.factorsOf)(this));
	}
	set getTetrahedral(v) {
		this._getTetrahedral = v;
	}
	get getTetrahedral() {
		return this._getTetrahedral !== undefined
			? this._getTetrahedral
			: (this._getTetrahedral = (0, getTetrahedral_1.getTetrahedral)(this));
	}
	set isHappy(v) {
		throw "isHappy can not be set like this";
	}
	get isHappy() {
		var _a;
		return ((_a = this._isHappy) === null || _a === void 0
			? void 0
			: _a[10]) !== undefined
			? this._isHappy[10]
			: (this._isHappy[10] = (0, isHappy_1.isHappy)(this, 10));
	}
	set isOdious(v) {
		this._isOdious = v;
	}
	get isOdious() {
		return this._isOdious !== undefined
			? this._isOdious
			: (this._isOdious = (0, isOdious_1.isOdious)(this));
	}
	set isPrimePower(v) {
		this._isPrimePower = v;
	}
	get isPrimePower() {
		return this._isPrimePower !== undefined
			? this._isPrimePower
			: (this._isPrimePower = (0, isPrimePower_1.isPrimePower)(this));
	}
	set isSelf(v) {
		throw "isSelf can not be set like this";
	}
	get isSelf() {
		var _a;
		return ((_a = this._isSelf) === null || _a === void 0 ? void 0 : _a[10]) !==
			undefined
			? this._isSelf[10]
			: (this._isSelf[10] = (0, isSelf_1.isSelf)(this, 10));
	}
	set mobius(v) {
		this._mobius = v;
	}
	get mobius() {
		return this._mobius !== undefined
			? this._mobius
			: (this._mobius = (0, mobius_1.mobius)(this));
	}
	set getAliquotSum(v) {
		this._getAliquotSum = v;
	}
	get getAliquotSum() {
		return this._getAliquotSum !== undefined
			? this._getAliquotSum
			: (this._getAliquotSum = (0, getAliquotSum_1.getAliquotSum)(this));
	}
	set hasIntRoot(v) {
		this._hasIntRoot = v;
	}
	get hasIntRoot() {
		return this._hasIntRoot !== undefined
			? this._hasIntRoot
			: (this._hasIntRoot = (0, hasIntRoot_1.hasIntRoot)(this));
	}
	set isImpolite(v) {
		this._isImpolite = v;
	}
	get isImpolite() {
		return this._isImpolite !== undefined
			? this._isImpolite
			: (this._isImpolite = (0, isImpolite_1.isImpolite)(this));
	}
	set isPerfect(v) {
		this._isPerfect = v;
	}
	get isPerfect() {
		return this._isPerfect !== undefined
			? this._isPerfect
			: (this._isPerfect = (0, isPerfect_1.isPerfect)(this));
	}
	set isSelfPrime(v) {
		this._isSelfPrime = v;
	}
	get isSelfPrime() {
		return this._isSelfPrime !== undefined
			? this._isSelfPrime
			: (this._isSelfPrime = (0, isSelfPrime_1.isSelfPrime)(this));
	}
	set isTetrahedral(v) {
		this._isTetrahedral = v;
	}
	get isTetrahedral() {
		return this._isTetrahedral !== undefined
			? this._isTetrahedral
			: (this._isTetrahedral = (0, isTetrahedral_1.isTetrahedral)(this));
	}
	set getCenteredHexagonal(v) {
		this._getCenteredHexagonal = v;
	}
	get getCenteredHexagonal() {
		return this._getCenteredHexagonal !== undefined
			? this._getCenteredHexagonal
			: (this._getCenteredHexagonal = (0,
			  getCenteredHexagonal_1.getCenteredHexagonal)(this));
	}
	set isAbundant(v) {
		this._isAbundant = v;
	}
	get isAbundant() {
		return this._isAbundant !== undefined
			? this._isAbundant
			: (this._isAbundant = (0, isAbundant_1.isAbundant)(this));
	}
	set isPolite(v) {
		this._isPolite = v;
	}
	get isPolite() {
		return this._isPolite !== undefined
			? this._isPolite
			: (this._isPolite = (0, isPolite_1.isPolite)(this));
	}
	set isPronic(v) {
		this._isPronic = v;
	}
	get isPronic() {
		return this._isPronic !== undefined
			? this._isPronic
			: (this._isPronic = (0, isPronic_1.isPronic)(this));
	}
	set isSemiperfect(v) {
		this._isSemiperfect = v;
	}
	get isSemiperfect() {
		return this._isSemiperfect !== undefined
			? this._isSemiperfect
			: (this._isSemiperfect = (0, isSemiperfect_1.isSemiperfect)(this));
	}
	set isUntouchable(v) {
		this._isUntouchable = v;
	}
	get isUntouchable() {
		return this._isUntouchable !== undefined
			? this._isUntouchable
			: (this._isUntouchable = (0, isUntouchable_1.isUntouchable)(this));
	}
	set getCountDivisors(v) {
		this._getCountDivisors = v;
	}
	get getCountDivisors() {
		return this._getCountDivisors !== undefined
			? this._getCountDivisors
			: (this._getCountDivisors = (0, getCountDivisors_1.getCountDivisors)(
					this
			  ));
	}
	set isArithmetic(v) {
		this._isArithmetic = v;
	}
	get isArithmetic() {
		return this._isArithmetic !== undefined
			? this._isArithmetic
			: (this._isArithmetic = (0, isArithmetic_1.isArithmetic)(this));
	}
	set isMersennePrime(v) {
		this._isMersennePrime = v;
	}
	get isMersennePrime() {
		return this._isMersennePrime !== undefined
			? this._isMersennePrime
			: (this._isMersennePrime = (0, isMersennePrime_1.isMersennePrime)(this));
	}
	set isPowerOf2(v) {
		this._isPowerOf2 = v;
	}
	get isPowerOf2() {
		return this._isPowerOf2 !== undefined
			? this._isPowerOf2
			: (this._isPowerOf2 = (0, isPowerOf2_1.isPowerOf2)(this));
	}
	set isUnusual(v) {
		this._isUnusual = v;
	}
	get isUnusual() {
		return this._isUnusual !== undefined
			? this._isUnusual
			: (this._isUnusual = (0, isUnusual_1.isUnusual)(this));
	}
	set semiperfectTest(v) {
		this._semiperfectTest = v;
	}
	get semiperfectTest() {
		return this._semiperfectTest !== undefined
			? this._semiperfectTest
			: (this._semiperfectTest = (0, semiperfectTest_1.semiperfectTest)(this));
	}
	set getIntRoot(v) {
		this._getIntRoot = v;
	}
	get getIntRoot() {
		return this._getIntRoot !== undefined
			? this._getIntRoot
			: (this._getIntRoot = (0, getIntRoot_1.getIntRoot)(this));
	}
	set isCenteredHexagonal(v) {
		this._isCenteredHexagonal = v;
	}
	get isCenteredHexagonal() {
		return this._isCenteredHexagonal !== undefined
			? this._isCenteredHexagonal
			: (this._isCenteredHexagonal = (0,
			  isCenteredHexagonal_1.isCenteredHexagonal)(this));
	}
	set isRound(v) {
		throw "Search code for: b521f257-c885-5b59-9852-0c5324408822";
	}
	get isRound() {
		throw "Search code for: 5620059f-ad6f-5f43-88ad-7c1adbc23c8b";
	}
	set isSophieGermainPrime(v) {
		this._isSophieGermainPrime = v;
	}
	get isSophieGermainPrime() {
		return this._isSophieGermainPrime !== undefined
			? this._isSophieGermainPrime
			: (this._isSophieGermainPrime = (0,
			  isSophieGermainPrime_1.isSophieGermainPrime)(this));
	}
	set isWeird(v) {
		this._isWeird = v;
	}
	get isWeird() {
		return this._isWeird !== undefined
			? this._isWeird
			: (this._isWeird = (0, isWeird_1.isWeird)(this));
	}
	set sieve(v) {
		this._sieve = v;
	}
	get sieve() {
		return this._sieve !== undefined
			? this._sieve
			: (this._sieve = (0, sieve_1.sieve)(this));
	}
	set getPoliteness(v) {
		this._getPoliteness = v;
	}
	get getPoliteness() {
		return this._getPoliteness !== undefined
			? this._getPoliteness
			: (this._getPoliteness = (0, getPoliteness_1.getPoliteness)(this));
	}
	set isEven(v) {
		this._isEven = v;
	}
	get isEven() {
		return this._isEven !== undefined
			? this._isEven
			: (this._isEven = (0, isEven_1.isEven)(this));
	}
	set isNatural(v) {
		this._isNatural = v;
	}
	get isNatural() {
		return this._isNatural !== undefined
			? this._isNatural
			: (this._isNatural = (0, isNatural_1.isNatural)(this));
	}
	set isPractical(v) {
		this._isPractical = v;
	}
	get isPractical() {
		return this._isPractical !== undefined
			? this._isPractical
			: (this._isPractical = (0, isPractical_1.isPractical)(this));
	}
	set isSad(v) {
		throw "isSad can not be set like this";
	}
	get isSad() {
		var _a;
		return ((_a = this._isSad) === null || _a === void 0 ? void 0 : _a[10]) !==
			undefined
			? this._isSad[10]
			: (this._isSad[10] = (0, isSad_1.isSad)(this, 10));
	}
	set isSphenic(v) {
		this._isSphenic = v;
	}
	get isSphenic() {
		return this._isSphenic !== undefined
			? this._isSphenic
			: (this._isSphenic = (0, isSphenic_1.isSphenic)(this));
	}
	set isWhole(v) {
		this._isWhole = v;
	}
	get isWhole() {
		return this._isWhole !== undefined
			? this._isWhole
			: (this._isWhole = (0, isWhole_1.isWhole)(this));
	}
}
exports.EnhancedNumber = EnhancedNumber;
exports.instantiatedNumbers = {};
function backupComputations(inputN) {
	const n = new EnhancedNumber(inputN);
	const fs = require("fs");
	const en = Object.assign(Object.assign({}, n), { _sieve: undefined });
	fs.appendFileSync("computedNumbers.json", `"${n}": ${JSON.stringify(en)},\n`);
}
exports.backupComputations = backupComputations;
let tempComputedNumbers;
try {
	tempComputedNumbers = JSON.parse(
		fs_1.default.readFileSync("computedNumbers.json", "utf8")
	);
} catch (e) {
	tempComputedNumbers = {};
}
const computedNumbers = tempComputedNumbers;
function restoreComputations(inputN) {
	for (const key of Object.keys(computedNumbers[inputN])) {
		if (key[0] == "_" && computedNumbers[inputN][key] !== undefined) {
			new EnhancedNumber(inputN)[key] = computedNumbers[inputN][key];
		}
	}
}
exports.restoreComputations = restoreComputations;
//# sourceMappingURL=enhancedNumber.js.map
