"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCountDivisors = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const factorsOf_1 = require("./factorsOf");
function getCountDivisors(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._getCountDivisors !== undefined) {
		return n.getCountDivisors;
	}
	let factors = (0, factorsOf_1.factorsOf)(Math.abs(n.number));
	const powers = factors.map((factor) => factor.power);
	let divisors = 1;
	for (const num of powers) {
		divisors *= num + 1;
	}
	if (n.number < 0) {
		divisors *= 2;
	}
	n.getCountDivisors = divisors;
	return n.getCountDivisors;
}
exports.getCountDivisors = getCountDivisors;
//# sourceMappingURL=getCountDivisors.js.map
