"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isKRough = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const factorsOf_1 = require("./factorsOf");
const isOdd_1 = require("./isOdd");
function isKRough(inputN, k) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n.number < 0) {
		return false;
	}
	if (k === 2) {
		return true;
	}
	if ((0, isOdd_1.isOdd)(n.number) && k === 3) {
		return true;
	}
	if ((0, factorsOf_1.factorsOf)(n).filter((v) => v.prime < k).length > 0) {
		return false;
	}
	return true;
}
exports.isKRough = isKRough;
//# sourceMappingURL=isKRough.js.map
