"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSphenic = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const factorsOf_1 = require("./factorsOf");
const getCountDivisors_1 = require("./getCountDivisors");
function isSphenic(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._isSphenic !== undefined) {
		return n.isSphenic;
	}
	if (n.number <= 0) {
		n.isSphenic = false;
		return n.isSphenic;
	}
	if (n.number === 1) {
		n.isSphenic = false;
		return n.isSphenic;
	}
	if ((0, getCountDivisors_1.getCountDivisors)(n) === 8) {
		if ((0, factorsOf_1.factorsOf)(n).length === 3) {
			n.isSphenic = true;
			return n.isSphenic;
		}
	}
	n.isSphenic = false;
	return n.isSphenic;
}
exports.isSphenic = isSphenic;
//# sourceMappingURL=isSphenic.js.map
