"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTetrahedral = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const getTetrahedral_1 = require("./getTetrahedral");
function isTetrahedral(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._isTetrahedral !== undefined) {
		return n.isTetrahedral;
	}
	let c = 1;
	let nth = (0, getTetrahedral_1.getTetrahedral)(c);
	while (Math.abs(n.number) > nth) {
		nth = (0, getTetrahedral_1.getTetrahedral)(++c);
	}
	return (n.isTetrahedral = Math.abs(n.number) === nth);
}
exports.isTetrahedral = isTetrahedral;
//# sourceMappingURL=isTetrahedral.js.map
