"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mobius = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const factorsOf_1 = require("./factorsOf");
function mobius(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._mobius !== undefined) {
		return n.mobius;
	}
	if (n.number === 0) {
		return 0;
	}
	let factors = (0, factorsOf_1.factorsOf)(Math.abs(n.number));
	if (factors.find((record) => record.power > 1)) {
		n.mobius = 0;
		return n.mobius;
	}
	if ((factors.length & 0b1) === 1) {
		n.mobius = -1;
		return n.mobius;
	}
	n.mobius = 1;
	return n.mobius;
}
exports.mobius = mobius;
//# sourceMappingURL=mobius.js.map
