"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sieve = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
function sieve(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._sieve !== undefined) {
		return n.sieve;
	}
	var primes = [2];
	let c = 2;
	while (++c <= n.number) {
		let sqrtC = Math.sqrt(c);
		let flag = true;
		for (const prime of primes) {
			if (prime > sqrtC) break;
			if (c % prime === 0) {
				flag = false;
				break;
			}
		}
		if (flag) {
			primes.push(c);
		}
	}
	n.sieve = primes;
	return n.sieve;
}
exports.sieve = sieve;
//# sourceMappingURL=sieve.js.map
